<?php
/* 
* wuWeather module - helper
* @copyright (C) 2012-2014 by feenders.de. All Rights Reserved.
* @license	GNU/GPL, see http://www.gnu.org/licenses/gpl-2.0.html
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * mod_mainmenu Helper class
 */
class modWuWeatherHelper
{
	/**
	 * Get weather object from URL
	 * @param unknown_type $url
	 * @param unknown_type $params
	 */
	public static function getWeatherData($url,&$params) {
		$w_file = md5($url).".json";
		$weather = null;
		if ($params->get('use_cache','1')==1) $weather = modWuWeatherHelper::getCacheFile($w_file);
		if (empty($weather)) {
			$allow = ini_get('allow_url_fopen');
			if (!empty($allow)) {
				$weather = @file_get_contents($url);
			} else if (function_exists('curl_exec')) { // try curl
				$weather = modWuWeatherHelper::getbyCurl($url);
			}
			if (!empty($weather) && ($params->get('use_cache')==1)) {
				modWuWeatherHelper::updateCache($w_file,$weather);
			}
		}
		return json_decode($weather);			
	}

	/**
	 * Try to get json-file by curl instead
	 * @param string $url
	 */
    public static function getbyCurl($url) {
		$ch = curl_init();
		$header = array();
		$header[0] = "Accept: text/xml,application/xml,application/xhtml+xml,";
		$header[0] .= "text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5";
		$header[] = "Cache-Control: max-age=0";
		$header[] = "Connection: keep-alive";
		$header[] = "Keep-Alive: 300";
		$header[] = "Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7";
		$header[] = "Accept-Language: en-us,en;q=0.5";
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $header); 
		curl_setopt($ch, CURLOPT_TIMEOUT, 180);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$weather = curl_exec($ch);
		curl_close($ch);
		return $weather; 
	}
	
	/**
	* Load cache file
	* returns empty if cache is expired or file does not exist
	* @param sting $filename  
	*/
    public static function getCacheFile($filename) {
		$weather = null;
		$cache_file = JPATH_BASE."/cache/".$filename;
		$cache_life = '1800';
		if (@file_exists($cache_file) && (time() - @filemtime($cache_file) <= $cache_life)){
			$weather = @file_get_contents($cache_file);
		}		
		return $weather;
	}

	/**
	* Update cache file
	* Writes the xml
	* @param string $filename  
	* @param string $content 
	*/
    public static function updateCache($filename,$content) {
		$cache_file = JPATH_BASE."/cache/".$filename;
		return @file_put_contents($cache_file,$content);
	}
	
}
