<?php
/**
* wuWeather module . wunderground.com weather module
* Displays current weather status at a module position
* @version 1.1 Jan 2014
* @author computer-daten-netze:feenders - dirk hoeschen
* @authorurl http://www.feenders.de
* @copyright (C) 2012-2013 by feenders.de. All Rights Reserved.
* @license	GNU/GPL, see http://www.gnu.org/licenses/gpl-2.0.html
*/

defined( '_JEXEC' ) or die( 'Direct Access not allowed.' );

jimport('joomla.filesystem.file');
require_once (dirname(__FILE__).'/helper.php');

// Lanugage matching Array. Only americans would not use the standard iso 
$lanuages = array("ZA"=>"AF","AL"=>"AL","AA"=>"AR","HY"=>"HY","AZ"=>"AZ","EU"=>"EU","BY"=>"BY","BU"=>"BU",
		"LI"=>"LI","MY"=>"MY","CA"=>"CA","CN"=>"CN","TW"=>"TW","HR"=>"CR","CZ"=>"CZ","DK"=>"DK","DV"=>"DV",
		"NL"=>"NL","GB"=>"EN","EO"=>"EO","ET"=>"ET","FA"=>"FA","FI"=>"FI","FR"=>"FR","FC"=>"FC","GZ"=>"GZ",
		"DE"=>"DL","KA"=>"KA","GR"=>"GR","GU"=>"GU","HT"=>"HT","IL"=>"IL","IN"=>"HI","HU"=>"HU","IS"=>"IS",
		"IO"=>"IO","ID"=>"ID","IR"=>"IR","IT"=>"IT","JP"=>"JP","JW"=>"JW","KM"=>"KM","KR"=>"KR","KU"=>"KU",
		"LA"=>"LA","LV"=>"LV","LT"=>"LT","ND"=>"ND","MK"=>"MK","MT"=>"MT","GM"=>"GM","MI"=>"MI","MR"=>"MR",
		"MN"=>"MN","NO"=>"NO","OC"=>"OC","PS"=>"PS","GN"=>"GN","PL"=>"PL","BR"=>"BR","PA"=>"PA","RO"=>"RO",
		"RU"=>"RU","SR"=>"SR","SK"=>"SK","SL"=>"SL","ES"=>"SP","SI"=>"SI","SE"=>"SW","CH"=>"CH","TL"=>"TL",
		"TT"=>"TT","TH"=>"TH","TR"=>"TR","TK"=>"TK","UA"=>"UA","US"=>"EN","UZ"=>"UZ","VN"=>"VU","CY"=>"CY",
		"SN"=>"SN","JI"=>"JI","YI"=>"YI");

// detect language 
$documnet = JFactory::getDocument();
$language = strtoupper(substr($documnet->language,3,2));
$language = (isset($lanuages[$language])) ? $lanuages[$language] : "EN"; 

$moduleclass_sfx = htmlspecialchars($params->get('moduleclass_sfx'));

// build  API url for current conditiion
$weather_url = "https://api.wunderground.com/api/"
		.urlencode(trim($params->get("api_key")))
		."/lang:".$language
		."/conditions/q/"
		.urlencode(trim($params->get('county','germany')))."/"
		.urlencode(trim($params->get('town','berlin')))."/"
		.".json";

// get current condition
$weather = modWuWeatherHelper::getWeatherData($weather_url,$params);

// get forecast conditions
if ($params->get('show_forecast','1')==1) {
	$weather_url = "https://api.wunderground.com/api/"
			.urlencode(trim($params->get("api_key")))
			."/lang:".$language
			."/forecast/q/"
			.urlencode(trim($params->get('county','germany')))."/"
			.urlencode(trim($params->get('town','berlin')))."/"
			.".json";
	$forecast = modWuWeatherHelper::getWeatherData($weather_url,$params);	
}

// load the template
if (empty($weather) || !isset($weather->current_observation)) {
	if ($params->get('show_errors','0')==1) :
		echo "<div class='mod_weather".$moduleclass_sfx."'>";
		echo "<p>".$params->get('error_msg','Unable to get weather data from wunderground.com')."</p>";
		if (isset($weather->response->error->description)) echo "<p>".$weather->response->error->description."</p>"; 
		echo "</div>";
 	endif;
} else {
	require JModuleHelper::getLayoutPath('mod_wuweather', $params->get('layout', 'default'));
}
